#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: system_init.pl, v1.1.0.0 Thu 10 Apr 2008 01:20:42 AM CEST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.

# This script is called through a cronjob at certain intervals and then it polls CCE,
# and runs /usr/sausalito/ui/web/vz/traffic/system_initialize.php to serialize the 
# resulting data.

$whatami = "constructor";

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Location of the config file:
$customers_Config = "/usr/sausalito/tmp/key.conf";
$customers_Dir = "/usr/sausalito/tmp";
$customers_Verify = "/usr/sausalito/tmp/verify.conf";

# Config file present?
if (-e $customers_Config) {
        &main;
}
else {
	&main;
}

sub main {

    &dircreate;

    @oids = $cce->find('Wizard_License');
    if ($#oids < 0) {
        # Nothing found
	system("/bin/rm -f $customers_Config");
    }
    else {
	system("/bin/rm -f $customers_Config");
	open(OUT,">$customers_Config") || die "Can't write to $customers_Config";
    	foreach $customer_oid (@oids) {
	    &getuser;
	    if ($user->{'full_license_data'} ne "") {
		$data = $user->{'full_license_data'};
		$data =~ s/\r//;
	        &printuser;
	    }
	}
	close OUT;
	system("/bin/chmod 600 $customers_Config");
    }
    system("/usr/bin/php /usr/sausalito/ui/web/vz/traffic/system_initialize.php");
    system("/bin/chmod 777 $customers_Dir");
    if (-f $customers_Verify) {
	system("/bin/chmod 644 $customers_Verify");
	system("/bin/chown apache:apache $customers_Verify");
    }
}

sub getuser {
     ($ok, $user) = $cce->get($customer_oid);
}

sub printuser {
	open(COUT,">$customers_Config") || die "Can't write to $customers_Config";
	print COUT "$data";
	close COUT;
	system("/bin/chmod 600 $customers_Config");
	system("/bin/chmod 777 $customers_Dir");
}

sub dircreate {
    if (!-d "$customers_Dir") {
	system("/bin/mkdir $customers_Dir");
	system("/bin/chmod 777 $customers_Dir");
	&main;
    }
}

$cce->bye('SUCCESS');
exit(0);

